#ifndef __OBJECT_H__
#define __OBJECT_H__

#include "lib3ds/file.h"
#include "lib3ds/mesh.h"
#include "lib3ds/node.h"
#include "lib3ds/vector.h"
#include "lib3ds/material.h"
#include "f3Dutils.h"
#include "Render.h"

class Object
{
 private:
	Lib3dsFile* file;
	Render *rd;
	float scalefactor;
	
 public:
	Object(char *filename, Render *rd, float scalefactor = 1.0);
	~Object();
	void render();
};

#endif //__OBJECT_H__
