/* Essai sur quaternions */

#ifndef QUAT_H
#define QUAT_H

typedef float fMatrix[12];

class Quat
{
 public:
  float x,y,z,w;

  void CreateFromAxis(float X, float Y, float Z, float angle);
  void ToMatrix(fMatrix M);
  void CreateFromEuler( float ax, float ay, float az);
  void mult( Quat q2);
  //  0<t<1, OMEGA = angle (A,B)
  void Slerp(const Quat &A, const Quat &B, 
	     const float t /* , const float OMEGA */);
};

#endif // QUAT_H
