// class sable :: plutot fire en fait

#ifndef SABLE1_H
#define SABLE1_H

struct t_s1 {
  float p[3];
  float p0[3];	// x,y,z
  float v0[3];	// vx,vy,vz
  float a0[3];	// ax,ay,az
  float lifetot;
  float life;
  float lifedeb;
  float intensite;
  Uint32 col;
  int img;
};


class parts;
class Sable
{
 public:
  Sable(int nb, int cx, int cy);	// constructeur
  Sable(Sable *sable);
  ~Sable();		// destructeur
  void pixel(int x, int y, Uint32 color,Uint32 *buffer, t_s1 *s);
  int go(Uint32 time, Uint32 *buffer);
  void setcx(int cx_) { cx = cx_; }
  void setcy(int cy_) { cy = cy_; }
  
 private:
  static int nb_inf;
  void gen_star(t_s1 *s,float ft1);
  void update_star(t_s1 *s, float ft1);
  int cx, cy;
  int nb_star;		// nb d'toiles
  t_s1 *s1;		// nb_star particles primaires
  SDL_Surface *sprite;
  parts* part;
};

#endif SABLE1_H
