// Moteur 3d de Ced
// version modifie par Maxwell
// support de polygones  n cots (non totalement test)
// todo: euh, on passe en entiers ?
// ptain c'est chiant...

#include "effets.h" 

int is_poly_out (int nb_vect, iVector vertex[])
{
	int xs=0, ys=0, xi=0, yi=0;
	for (int i=0; i<nb_vect; i++) {
		if (vertex[i][VECT_X]>=319*65536) xs++;
		if (vertex[i][VECT_Y]>=239*65536) ys++;
		if (vertex[i][VECT_X]<=-320*65536) xi++;
		if (vertex[i][VECT_Y]<=-24065536) yi++;
	}
	if ( (xi>=nb_vect) || (xs>=nb_vect) || (yi>=nb_vect) || (ys>=nb_vect) ) return 1;
	return 0;
}

static
int is_visible(int x1, int y1, int x2, int y2, 
							 int x3, int y3)
{
	int ix1 =  x1>>16, ix2 =  x2>>16, ix3 =  x3>>16,
	    iy1 =  y1>>16, iy2 =  y2>>16, iy3 =  y3>>16;
	int dx = ix1 - ix2;
	int dy = iy1 - iy2;
	int dX = ix2 - ix3;
	int dY = iy2 - iy3;
	int z = dx * dY - dX * dy;
	return (z>0);
}

void scanit(int l, int iVx, int iVy, int wtex, 
	    int iVXpad, int iVYpad, Uint32 *screen, Uint32 *tex, Uint32 d2)
{
	for( int x=0; x< l; x++) {
	 	int iVxr =  iVx>>16; int iVyr = iVy>>16;
		screen[ x ] = tex[ iVxr + iVyr * wtex ];
		iVx += iVXpad; iVy += iVYpad;
	}
}

void pix_filt(Uint32 *screen, int x, Uint32 *pa, Uint32 *pc,
						 int dx, int dy)
{
	Uint32 a = *pa, b = *(pa+1), c = *pc, d= *(pc+1);
	Uint32 a1 = a&BMASK, b1 = b&BMASK,
				 c1 = c&BMASK, d1 = d&BMASK;
	int idx = 255-dx; int idy = 255-dy; 
	Uint32 bcolor = (a1*idx*idy + b1*dx*idy + c1*idx*dy + d1*dx*dy) >> 16;
	a1 = a&GMASK, b1 = b&GMASK,
	c1 = c&GMASK, d1 = d&GMASK;
	Uint32 gcolor = (a1*idx*idy + b1*dx*idy + c1*idx*dy + d1*dx*dy) >> 16;

	a1 = (a&RMASK)>>16, b1 = (b&RMASK)>>16,
	c1 = (c&RMASK)>>16, d1 = (d&RMASK)>>16;
	Uint32 rcolor = (a1*idx*idy + b1*dx*idy + c1*idx*dy + d1*dx*dy);

	// Uint32 oldscreen = screen[ x ];
	Uint32 blue = /* (oldscreen&BMASK); */ (bcolor&BMASK);
	if (blue>255) blue = 255;
	
	screen[ x ] = (blue) |(gcolor&GMASK)|(rcolor&RMASK);
}

void scanit2(int l, int iVx, int iVy, int wtex, 
	     int iVXpad, int iVYpad, Uint32 *screen, Uint32 *tex, Uint32 d2, Uint32 opts)
{
	for( int x=0; x< l; x++) {
	 	int iVxr =  iVx>>16; int iVyr = iVy>>16;
		Uint32 *pa = ( tex + iVxr + iVyr * wtex);
		Uint32 *pc = ( tex + iVxr + (iVyr+1) * wtex );

		int dx = (iVx&0xFFFF)>>8; int dy = (iVy&0xFFFF)>>8;
		if(opts&TRANSPARENCY) mmx_pixfilt_add(screen+x, pa, pc, dx, dy, d2);
		else mmx_pixfilt(screen+x, pa, pc, dx, dy, d2);
		//pix_filt(screen, x, pa, pc, dx, dy);
		iVx += iVXpad; iVy += iVYpad;
	}
}


void do_scanline(int y, int ixg, int ixd, int iVXpad, int iVYpad, 
		 int posy, Uint32 *tex, int wtex, int htex, int iVx, int iVy,
		 Uint32 *screen, Uint32 d2, Uint32 opts)
{
	if ( ( y >=  0 ) && ( y <  480 ) ) {
		if (ixg<0) {
			if (ixd<0) return;
			for (int x= ixg; x<0; x+=65536) {
				iVx += iVXpad; iVy += iVYpad;
			}
			ixg = 0;
		}
		if (ixd>639*65536) {
			if (ixg>639*65536) return;
			ixd = 639*65536;
		} 
		int ixgr = ixg>>16, ixdr = ixd>>16;

		int off = posy+ixgr;
		int l = ixdr-ixgr;
		if (l==0) return;

//		printf("xg:%d, xd:%d, y:%d, posy:%d, iVx:%d, iVy:%d\n",
//						ixgr, ixdr,		y,		posy,		iVx>>16, iVy>>16); fflush(stdout);

//		printf("iVx:%d iVy:%d iVXpad:%d iVYpad:%d\n",
//			(iVx&255), (iVy&255), (iVXpad&255), (iVYpad&255) );

		scanit2(l, iVx, iVy, wtex, iVXpad, iVYpad, screen+off, tex, d2, opts);
		/*		if (opts&BILINEAR_FILT) {
		        mmx_scanit_filt(l, iVx, iVy, wtex, iVXpad, iVYpad, screen+off, tex, d2);
			//scanit(l, iVx, iVy, wtex, iVXpad, iVYpad, screen+off, tex, d2);
		}
		else {
			if (opts&TRANSPARENCY) {
				scanit2(l, iVx, iVy, wtex, iVXpad, iVYpad, screen+off, tex, d2);
			}
			else {
				mmx_scanit_notrans(l, iVx, iVy, wtex, iVXpad, iVYpad, screen+off, tex);
			}
			}
		*/
	}
}

void avance(int &valeur, int suiv, const int nbseg)
{
	valeur += suiv;
	if (valeur<0) valeur += nbseg;
	valeur = valeur % nbseg;
}

void prepval(int &dir, int suiv, iVector vertex[], iVector vtex[], 
						int &ix, int &iVx, int &iVy, int &ixs, int &iVxs, int &iVys, int y,
						int nbseg)
{
	int ddy = (vertex[dir][VECT_Y]>>16)-y;
	while (ddy==0) {
		ix = vertex[dir][VECT_X];
		iVx = vtex[dir][VECT_X]; iVy = vtex[dir][VECT_Y];
		avance(dir, suiv, nbseg); // - pour gauche, + pour droite
		ddy = (vertex[dir][VECT_Y]>>16)-y;
	}
	int ixvtex = vtex[dir][VECT_X];
	int iyvtex = vtex[dir][VECT_Y];
	int ixvertex = vertex[dir][VECT_X];
	ixs = (ixvertex-ix)/ddy;
	iVxs = (ixvtex-iVx)/ddy;
	iVys = (iyvtex-iVy)/ddy;
}


int changevect(int &ix, int &iVx, int &iVy, int &ixs, int &iVxs, int &iVys, 
							 int nbseg, iVector vertex[], iVector vtex[], int suiv, int y, int &dir)
{
	ix = vertex[dir][VECT_X];
	iVx = vtex[dir][VECT_X]; iVy = vtex[dir][VECT_Y];
	avance(dir, suiv, nbseg);
	int ddy = (vertex[dir][VECT_Y]>>16)-y;
	int dir2 = dir;
	avance(dir2, -suiv, nbseg);
	while (ddy==0) {
		if (dir2==dir) return -2;
		ix = vertex[dir][VECT_X];
		iVx = vtex[dir][VECT_X]; iVy = vtex[dir][VECT_Y];
		avance(dir, suiv, nbseg);
		ddy = (vertex[dir][VECT_Y]>>16)-y;
	}
	if ( y>= vertex[dir][VECT_Y]>>16 ) {
		return -1;
	}
	int ixvtex = vtex[dir][VECT_X];
	int iyvtex = vtex[dir][VECT_Y];
	int ixvertex = vertex[dir][VECT_X];
	ixs = ( ixvertex - ix )/ddy;
	iVxs = ((ixvtex-iVx))/ddy;
	iVys = ((iyvtex-iVy))/ddy;
	return 0;
}


// Rendu de l'image
void render_tri( Uint32 *screen, iVector vertex[], iVector vtex[],
		 Uint32 *tex, int wtex, int htex, Uint32 opts, int nbseg, Uint32 d2 )
{

	// Polygones en dehors de l'ecran totalement
	if ( is_poly_out (nbseg, vertex)) return;

	int suiv = -1;
	//  (x1-x2)*(y2-y3) - (x2-x3)*(y1-y2)
	if (is_visible(vertex[0][VECT_X], vertex[0][VECT_Y], vertex[1][VECT_X], vertex[1][VECT_Y], 
							 vertex[nbseg-1][VECT_X], vertex[nbseg-1][VECT_Y])) {
		if ( opts & CULL_FACE ) {
			return;
		}
		else {
			suiv = 1;
		}
	}

	// A mettre ailleurs a terme...
	// rajoute les xc et yc
	for (int i=0; i<nbseg; i++) {
		vertex[i][VECT_X] += 320*65536;
		vertex[i][VECT_Y] += 240*65536;
	}

	// Sommet le plus haut
	int first = 0;
	int last = 0;
	int max = vertex[0][VECT_Y];
	int min = vertex[0][VECT_Y];
	for (int i=0; i<nbseg; i++) {
		if (min>vertex[i][VECT_Y]) {
			min = vertex[i][VECT_Y];
			first = i;
		}
		if (max<vertex[i][VECT_Y]) {
			max = vertex[i][VECT_Y];
			last = i;
		}
	}

	min = min>>16;
	max = max>>16;
	if (min==max) return;

	int droite = first+suiv;
	int gauche = first-suiv;
	if (gauche<0) gauche+=nbseg;
	if (droite<0) droite+=nbseg;
	gauche = gauche % nbseg;
	droite = droite % nbseg;

	int y = vertex[first][VECT_Y]>>16;
	int ypos = y*640;

	// printf ("%d\n",vertex[first][VECT_Y]);

	int ixd = vertex[first][VECT_X];
	int ixg = ixd;

	int iVxg, iVxd, iVyg, iVyd;
	iVxg = iVxd = vtex[first][VECT_X];
	iVyg = iVyd = vtex[first][VECT_Y];

	int ixgs, iVxgs, iVygs;
	prepval(gauche, -suiv, vertex, vtex, ixg, iVxg, iVyg, ixgs, iVxgs, iVygs, y, nbseg);

	int ixds, iVxds, iVyds;
	prepval(droite, suiv, vertex, vtex, ixd, iVxd, iVyd, ixds, iVxds, iVyds, y, nbseg);	

	while ( (y<=max)&&(y<480) ) {	
		int iVXpadd = 0, iVYpadd = 0;
		int rixdiff = (ixd-ixg)>>16;
		if (rixdiff>0) {
			int iVxdiff = iVxd-iVxg;
			int iVydiff = iVyd-iVyg;
			iVXpadd=(iVxdiff/rixdiff);
			iVYpadd=(iVydiff/rixdiff);
			do_scanline(y, ixg, ixd, iVXpadd, iVYpadd, ypos, tex, wtex, htex, 
				    iVxg, iVyg, screen, d2, opts);
		}
		ixd += ixds;
		ixg += ixgs;
		iVxd += iVxds; iVyd += iVyds;
		iVxg += iVxgs; iVyg += iVygs;
		y++;
		ypos+=640;
		if (y == vertex[gauche][VECT_Y]>>16) {
			if (changevect(ixg, iVxg, iVyg, ixgs, iVxgs, iVygs, 
					nbseg, vertex, vtex, -suiv, y, gauche)!=0) break;
		}
		if (y == vertex[droite][VECT_Y]>>16) {
			if (changevect(ixd, iVxd, iVyd, ixds, iVxds, iVyds, 
				       nbseg, vertex, vtex, suiv, y, droite)!=0) break;
		}
	}
	//asm_emms();
}

// end of render_tri.cc
