// Complmentaire de obj2.h

#ifndef __3D_H
#define __3D_H

#define XOFF 320
#define YOFF 240
#define ZOFF 100  // 0<z<100
#define ZMAX 500

#define N_VECTORS 8

fVector triangle[] = { {  -50.0,  50.0,  100.0 },
		       {  100.0,  100.0,   50.0 },
		       {   63.0,    0.0,    0.0 } };

fVector cube[] = { {-100, 100, 100 }, //haut gauche
		  { 100, 100, 100 }, //haut droit
		  { 100,-100, 100 }, //bas droit
		  {-100,-100, 100 }, //bas gauche
		  {-100, 100,-100 }, //haut gauche
		  { 100, 100,-100 }, //haut droit
		  { 100,-100,-100 }, //bas droit
		  {-100,-100,-100 } }; //bas gauche

#define N_POLYS 12

fVector PolyCube[][3] = {{ {-100, 100, 100 }, //haut gauche
			   { 100, 100, 100 }, //haut droit
			   { 100,-100, 100 } }, //bas droit
			 { {-100, 100, 100 }, //haut gauche
			   { 100,-100, 100 }, //bas droit
			   {-100,-100, 100 } }, //bas gauche

			 { {-100, 100,-100 }, //haut gauche
			   { 100,-100,-100 }, //bas droit
			   { 100, 100,-100 } }, //haut droit
			 { {-100, 100,-100 }, //haut gauche
			   {-100,-100,-100 }, //bas gauche
			   { 100,-100,-100 } }, //bas droit

			 { { 100,-100, 100 },
			   { 100, 100, 100 },
			   { 100, 100,-100 } },
			 { { 100,-100, 100 },
			   { 100, 100,-100 },
			   { 100,-100,-100 } },

			 { {-100,-100, 100 },
			   {-100, 100,-100 },
			   {-100, 100, 100 } },
			 { {-100,-100, 100 },
			   {-100,-100,-100 },
			   {-100, 100,-100 } },

			 { { 100, 100,-100 }, //haut gauche
                           { 100, 100, 100 }, //haut droit
                           {-100, 100, 100 } }, //bas droit
                         { { 100, 100,-100 }, //haut gauche
                           {-100, 100, 100 }, //bas droit
                           {-100, 100,-100 } }, //bas gauche

                         { { 100,-100,-100 }, //haut gauche
                           {-100,-100, 100 }, //bas droit
                           { 100,-100, 100 } }, //haut droit
                         { { 100,-100,-100 }, //haut gauche
                           {-100,-100,-100 }, //bas gauche
                           {-100,-100, 100 } } //bas droit
			                      };


fVector PolyTex[][3] = { { {   0, 128, 128 }, //haut gauche
                           { 128, 128, 128 }, //haut droit
                           { 128,   0, 128 } },
                         { {   0, 128, 128 }, //haut gauche
                           { 128,   0, 128 }, //bas droit
                           {   0,   0, 128 } }, //bas gauche

                         { {   0, 128,   0 }, //haut gauche
                           { 128,   0,   0 }, //bas droit
                           { 128, 128,   0 } }, //haut droit
                         { {   0, 128,   0 }, //haut gauche
                           {   0,   0,   0 }, //bas gauche
                           { 128,   0,   0 } }, //bas droit
						};

iVector iPolyTex[][3] = { { {   0, 128, 128 }, //haut gauche
                           { 128, 128, 128 }, //haut droit
                           { 128,   0, 128 } },
                         { {   0, 128, 128 }, //haut gauche
                           { 128,   0, 128 }, //bas droit
                           {   0,   0, 128 } }, //bas gauche

                         { {   0, 128,   0 }, //haut gauche
                           { 128,   0,   0 }, //bas droit
                           { 128, 128,   0 } }, //haut droit
                         { {   0, 128,   0 }, //haut gauche
                           {   0,   0,   0 }, //bas gauche
                           { 128,   0,   0 } }, //bas droit
			   };

#endif // __3D.H
