#ifndef __BLEND_H__
#define __BLEND_H__

#define RGBA_TO_RGBA 0
#define RGBA_TO_RGB 1
#define ADD_RGBA_TO_RGB 2
#define ADD_RGBA_TO_RGBA 2

typedef void (*TBlender)( void *src, int sw, void *dst, int dw, int w, int h, int a);

void mmx_blend_rgba_to_rgba( void *src, int sw, void *dst, int dw, int w, int h, int a) asm ("mmx_blend_rgba_to_rgba");
void mmx_blend_rgba_to_rgb( void *src, int sw, void *dst, int dw, int w, int h,int a) asm ("mmx_blend_rgba_to_rgb");
void mmx_add_blend_rgba_to_rgb( void *src, int sw, void *dst, int dw, int w, int h, int a) asm ("mmx_add_blend_rgba_to_rgb");
void mmx_add_blend_rgba_to_rgba( void *src, int sw, void *dst, int dw, int w, int h, int a) asm ("mmx_add_blend_rgba_to_rgba");

//void mmx_screen_copy( void *dst, void *src, int size ) asm ("mmx_screen_copy");
//void mmx_emms( void ) asm ("mmx_emms");

void mmxblend(void *src, int src_w, int src_h,
	      void *dst, int dst_w, int dst_h,
	      int sx, int sy, int dx, int dy,
	      int w, int h, int what, int a );

#endif
