// d'autres constructeurs !
#ifndef __OBJ3_H
#define __OBJ3_H

// Lettres (affichage)
class XLettre
{
	public:
		XLettre();
		~XLettre();
		int go (Uint32 *buffer, int xdest, int ydest, char text, uchar alpha);
		int W;
	private:
		SDL_Surface *font;
};

// Z2
class Z2
{
	public:
		Z2(); // constructeur
		~Z2(); // destructeur
		void go(int time);
		void affich(Uint32 *buffer, int time);
		SDL_Surface *tmp1;
	private:
		void racine();
		Uint32 text[128*128], text2[128*128]; // pour la texture
		
		int FOCUS;
		int pcalcx[256*256];
		int pcalcy[256*256];
		int pcalcz[256*256];
};

// son
class Son
{
	public:
		Son(int marche, int TAVANCE, char *zik);
		~Son();
		void start();
		void del();
		void vol(int vol);
	private:
		int SOUND;
		SMPEG *mpeg;
		int volume;
		SMPEG_Info info;
};

// face
class Face
{
 public:
  Face();
  ~Face();
  void go(Uint32 *buffer, int time, int time2, int type=0);
  void go2(Uint32 *buffer, Uint32 time, const Uint32 duree);
  void go3(Uint32 *buffer, Uint32 time, const Uint32 duree);
  void go4(Uint32 *buffer, Uint32 time);
  void go5(Uint32 *buffer, Uint32 time);
 private:
  SDL_Surface *face, *face2;
  int W,H;
};


#endif // __OBJ3_H
// end of obj3.h
