// Moteur 3d de Ced

#include <vector>
#include <iostream>

#include <stdlib.h>
#include "effets.h"
#include "3d.h"
#include "Render.h"
#include "lib3ds/material.h"
#include "Object.h"
#include "3DPath.h"

// Constructeur
_3D::_3D(Render *rd)
{
	this->rd = rd;
	avion1 = new Object(PATH_3D "palais.3ds",rd,1.0);
	avion2 = new Object(PATH_3D "stealth/stealth.3ds",rd);
}

// Destructeur
_3D::~_3D() { }

// Calcule les coordonnes camera/objets et affichage
void _3D::go(Uint32 *screen, Uint32 time)
{
	//avion2->render();

	const float T = M_PI/4000.0;
	rd->push_matrix();
	{
		
// 		//rd->scale(7,7,7);
		//rd->rotate(time*T + M_PI,time*T + M_PI,time*T);
		rd->rotate(M_PI/2,0,0);
		rd->translate(0.0,0.0,-300.0);
		avion1->render();
	}
	rd->pop_matrix();
}

