// ceci est le main de la dmo

#include <stdio.h>
#include <map>

#include "effets.h"
#include "SDL.h"
#include "time.h"

#include <unistd.h>

// test pour que ca compile + vite
#include "plan.h"
#include "landscape.h"
#include "timeparse.h"
#include "sable1.h"
#include "etoile.h"
#include "effet2.h"

void first_part(SDL_Surface *screen, SDL_Surface *screentmp, int TAVANCE, 
		SDL_Event event, int snd);
void second_part(SDL_Surface *screen, SDL_Surface *screentmp, int TAVANCE, 
		 SDL_Event event, int snd);


int main(int argc, char *argv[])
{
  printf("Taille de page:%d\n",(int) getpagesize());

  // *******************************
  // PREPARATIONS / INITIALISATIONS
  // *******************************

  // charge fichier de conf
  Conf conf(PATH_OTHER "demo.conf");

  int TAVANCE = conf.getTA();
  int WHICHPART= conf.getWP();
  int snd = conf.getSND();

  // l'cran
  SDL_Event event;
  SDL_Surface *screen,*screentmp;
  Uint32 videoflags = /* SDL_HWSURFACE | */  SDL_DOUBLEBUF /* | SDL_ASYNCBLIT */;

  // passe en plein cran si besoin
  if ( conf.getFS() ) videoflags |=  SDL_FULLSCREEN;

  Uint32 video_bpp = 32;

  /* Initialize SDL VIDEO */
  if ( SDL_Init(SDL_INIT_VIDEO|SDL_INIT_NOPARACHUTE) < 0 ) {
    fprintf(stderr, "Couldn't initialize SDL: %s\n",SDL_GetError());
    exit(1);
  }
  //atexit(SDL_Quit);
  /* Set 640x480 video mode */
  if ( (screen=SDL_SetVideoMode(640,480,video_bpp,videoflags)) == NULL ) {
    fprintf(stderr, "Couldn't set 640x480x%d video mode: %s\n",
            video_bpp, SDL_GetError());
    exit(2);
  }

  /* Ignore app focus and mouse motion events */
  //  SDL_EventState(SDL_ACTIVEEVENT, SDL_IGNORE);
  //  SDL_EventState(SDL_MOUSEMOTION, SDL_IGNORE);
  SDL_ShowCursor( 0 );

  screentmp = SDL_CreateRGBSurface (SDL_SWSURFACE, 640, 480, 32,0xFF0000,
				    0xFF00, 0xFF,0xFF000000);

  // randomization sur le timer
  srand( SDL_GetTicks() );

  //if (WHICHPART==1)
  first_part(screen, screentmp, TAVANCE, event, snd);

  //if (WHICHPART==2)
    second_part(screen, screentmp, TAVANCE, event, snd);

  // on se barre proprement
  SDL_FreeSurface(screentmp);
  SDL_Quit(); 
  return 0;
}



// *******************************
// FIRST PART
// *******************************
void first_part(SDL_Surface *screen, SDL_Surface *screentmp, int TAVANCE, 
				SDL_Event event, int snd)
{
	// parsage fichier de conf
	Timeparse timeparse(PATH_OTHER "timer1.cfg");

	// chargement des donnes
	scrolld scrolldebut(screen);	// dmarre le premier effet

	Logo logo1("  AABS  ","PRESENTS"); // premier logo
	Logo logo2("A NEW DEMO");
	Logo logo3("CALLED");
	Logo logo4("DINDE");

	Face face; // face
	move_tex transition(640,480,320,240); // ecran ki se barre dans le fond
	STAR3D star3D(20);

	// capture d'ecran
	int spec1 = 0;

	Son son1(snd, TAVANCE, PATH_ZIK "dinde1.mp3"); // dmarre son
	son1.start();

	Uint32 timeorig = SDL_GetTicks();
	Uint32 spent=0,time, lag=0, timeold=0;
	int done=0; 
	SDL_UpdateRect(screen,0,0,0,0);
	// boucle principale
	while (!done) {
		/* Check for events */
		while ( SDL_PollEvent(&event) ) {
			switch (event.type) {
			case SDL_KEYDOWN:  
				/* Escape pour quitter: voir SDL_keysym.h */
				if (event.key.keysym.sym==SDLK_ESCAPE) {done = 1;}
				break;   
			case SDL_QUIT:
				done = 1;   
				break;
			default:      
				break;
			}
		}
		LOCK_SURFACE (screen);
		LOCK_SURFACE (screentmp);
		Uint32 *buffer=(Uint32 *) screen->pixels;
		Uint32 *buftmp=(Uint32 *) screentmp->pixels;

		time = SDL_GetTicks()-timeorig + TAVANCE;
		if ( (time-timeold) > 40 ) lag++;
		timeold = time;
		// appel des fonctions

		if (time<=26000) {
			mmx_quaddel( buffer, 640*480/2, 0 );
			asm_emms();
		}

		Uint32 tdeb = 0, duree = 32500, tfin = tdeb+duree;
		if ((time>tdeb)&&(time<tfin)) {
			Uint32 transit = 5000;
			if (time<transit)
				star3D.go(buffer, time, time*20/transit);
			else
				star3D.go(buffer, time);
		}

		tdeb = 26000; tfin=56000;
		if ((time>tdeb)&&(time<tfin)) {
			scrolldebut.go(time-tdeb,buffer);	// go pour le scroll
		}

		/*    tdeb = 0;
			  duree = 32500;
			  tfin = tdeb+duree;
			  if ((time>tdeb)&&(time<tfin)) {
			  face.go4 (buffer, time);
			  }*/

		// lance logos
		logodemo(buffer, time, logo1, logo2, logo3, logo4);

		/*    tdeb = 20000;
			  duree = 2000;
			  tfin = tdeb+duree;
			  if ((time>tdeb)&&(time<tfin)) {
			  face.go3(buffer,time-tdeb);
			  }*/

		/*tdeb = tfin;
		  duree = 3000;
		  tfin = tdeb+duree;
		  if ((time>tdeb)&&(time<tfin)) {
		  face.go2(buffer,time-tdeb);
		  }*/

		/*tdeb = 40000;
		  duree = 4000;
		  tfin = tdeb+duree;
		  if ((time>tdeb)&&(time<tfin)) {
		  face.go5(buffer,time-tdeb);
		  }*/
    

		tdeb=56000;
		duree = 6000;
		tfin=tdeb+duree+1000;
		if ((time>tdeb)&&(time<tfin)) {
			int toto = 100-CLAMP(((time-tdeb)*100)/duree,0,100);
			son1.vol(toto);
			if(!toto) done=1;
		}

		duree = 1000;
		tfin = tdeb+duree+4000;
		if ((time>tdeb)&&(time<tfin)) {
			if (spec1<1) {
				scrolldebut.go(time,buftmp);
				spec1++;
			}
			mmx_quaddel( buffer, 640*480/2, 0 );
			asm_emms();
			int t=time-tdeb;
			int intens = 20 - ( (t*20)/4000 );
			if (intens<0) intens = 0;
			star3D.go(buffer, time, intens );
			transition.go(buffer,buftmp,t);
		}

		tdeb=tfin;
		duree = 4000;
		tfin=tdeb+duree;
		if ((time>tdeb)&&(time<tfin)) {
			mmx_quaddel( buffer, 640*480/2, 0 );
			asm_emms();			
		}

		map<const string, int> name_lookup;
		name_lookup["face1"] = 1;
		name_lookup["face2"] = 2;
		name_lookup["face3"] = 3;
		name_lookup["face4"] = 4;
		name_lookup["face5"] = 5;
		for (list<Func>::iterator ifunc = timeparse.lfunc.begin();
			 ifunc != timeparse.lfunc.end(); ++ifunc) {
			if ( timeparse.findTime(time, ifunc)) {
				const int tdeb = ifunc->timing.debut;
				const string fname = ifunc->fname;
				switch (name_lookup[fname]) 
					{
					case 2 : face.go2(buffer, time-tdeb, ifunc->timing.duree); break;
					case 3 : face.go3(buffer, time-tdeb, ifunc->timing.duree); break;
					case 4 : face.go4(buffer, time-tdeb); break;
					case 5 : face.go5(buffer, time-tdeb); break;
					}
			}
			else break;
		}


		SDL_Flip(screen);
		spent++;									// augmente le nb de frames
		UNLOCK_SURFACE(screen);
		UNLOCK_SURFACE(screentmp);
	}

	son1.del();
	printf("Frame/s moyen: %f, lag:%d\n",
		   (float) (spent*1000.0)/ (float) time, lag);
	printf("proportion lag: %f\n", (float) (lag*100)/ (float) spent);
	printf("time: %d\n",time);

}






// *******************************
// SECOND PART
// *******************************
void second_part(SDL_Surface *screen, SDL_Surface *screentmp, int TAVANCE, 
		 SDL_Event event, int snd)
{

  // parsage du timing
  Timeparse timeparse(PATH_OTHER "timer.cfg");

  // Display 3D
  Render rd;
  rd.set_screen((Uint32*)screen->pixels);
  // Camera
  move_cam cam(&rd);

  // chargement donnes
  _3D c3d(&rd); // moteur 3D
  scroll_miroir scmiroir(&rd);
  sarah_feu sarah_feu(&rd);
  marche marche(&rd);

  Sable sable1(5, 0, 0); // les particules
  fantomes fantom(&rd);
  diapofin diapofin(&rd);

  Plan plan1;	// plan textur
  lettres lettres1("DINDE [   DINDE IS NOT A DEMO [[[[[[",100,8,LETTRES_RANDOM,0);// effet lettres
  lettres lettres2("[ PLOUF [",100,4,LETTRES_CENTRE,200);
  greets greetings;
  //Z1 z1 ; // perlin noise
  //Z2 z2;
  parts myparts(&rd);
  //	toto toto1;
  //Nova nova1;
  
  generique generic(&rd);
  Landscape landscape;
  Etoile etoile(&plan1, timeparse.vpos, timeparse.vrot, sable1);

  fireball fball(&rd);
  
  // s'occupe du son
  Son son2(snd, TAVANCE, PATH_ZIK "dinde2.mp3"); // dmarre son
  son2.start();

  Uint32 spent=0;
  int time;
  int timeorig = SDL_GetTicks();
  int done = 0;
  SDL_UpdateRect(screen,0,0,0,0);
  // boucle principale

  while (!done) {
    /* Check for events */
    while ( SDL_PollEvent(&event) ) {
      switch (event.type) {
      case SDL_KEYDOWN:  
	/* Escape pour quitter: voir SDL_keysym.h */
	if (event.key.keysym.sym==SDLK_ESCAPE) {done = 1;}
	//if ( (event.key.keysym.sym==SDLK_UP) || (event.key.keysym.sym==SDLK_DOWN) ||
	//     (event.key.keysym.sym==SDLK_LEFT) || (event.key.keysym.sym==SDLK_RIGHT) )
	else  plan1.mouse(event);
	break;
      case SDL_QUIT:
	done = 1;
	break;

	// on chope la souris
      case SDL_MOUSEBUTTONDOWN:
	plan1.mouse(event);
	break;
      case SDL_MOUSEBUTTONUP:
	plan1.mouse(event);
	break;
      case SDL_MOUSEMOTION:
		  plan1.mouse(event);
	break;
	
      default:
	break;
      }
    }
    LOCK_SURFACE (screen);
    LOCK_SURFACE (screentmp);
    Uint32 *buffer=(Uint32 *) screen->pixels;
    Uint32 *buftmp=(Uint32 *) screentmp->pixels; // unused

    time = SDL_GetTicks()-timeorig + TAVANCE;

    // appel des fonctions

    // 		mmx_quaddel( buftmp, 640*480/2, 0xFF000000 );
    mmx_quaddel( buffer, 640*480/2, 0xFF000000 );
    asm_emms();

    // A FAIRE AVANT TOUTE 3D !!!
    cam.go(time);
	
    //		greetings.go( buftmp, time );

    //		int a = (int) ( 1+fabs(50*sin(time*0.001)) );
    //		plouf2( buffer, buftmp, a );
    //		plouf( buffer, buftmp );

    //plan1.coord(time); // bouge les coordonnes du plan
    //plan1.plan_txt(buffer); // plan textur

    
    
    //		plan1.do_lignes(buffer);
    //toto1.go(buffer,time);
    //cube1.go(buffer,time);
    //landscape.go(buffer, time);
    //scmiroir.go(buffer, time);

    // find the good efects to play
    map<const string, int> name_lookup;
    name_lookup["z1"] = 1;
    name_lookup["z2"] = 2;
    name_lookup["lettres1"] = 3;
    name_lookup["c3d"] = 4;
    name_lookup["landscape"] = 5;
    name_lookup["etoile"] = 6;
    name_lookup["scmiroir"] = 7;
    name_lookup["fireball"] = 9;
    name_lookup["sable"] = 10;
    name_lookup["plan"] = 12;
    name_lookup["myparts"] = 13;
    name_lookup["nova"] = 14;
    name_lookup["fantomes"] = 15;
    name_lookup["palais"] = 16;
    name_lookup["sarah_feu"] = 17;
    name_lookup["marche"] = 19;
    name_lookup["generic"] = 21;
	name_lookup["diapofin"] = 23;
    name_lookup["lettres2"] = 253;
    name_lookup["greetings"] = 255;
    for (list<Func>::iterator ifunc = timeparse.lfunc.begin();
	 ifunc != timeparse.lfunc.end(); ++ifunc) {
      if ( timeparse.findTime(time, ifunc)) {
	const int tdeb = ifunc->timing.debut;
	const string fname = ifunc->fname;
	switch (name_lookup[fname]) 
	  {
	    //case 1 : z1.go(buffer, time - tdeb); break;
	    //case 2 : z2.go(time);
	    //z2.affich(buffer, time); break;
	  case 3 : lettres1.go(buffer, time); break;
	  case 4 : c3d.go(buffer, time); break;
	  case 5 : landscape.go(buffer, time); break;
	  case 6 : 
	    if (tdeb>=0) 
	      etoile.go(buffer, time, false); 
	    else
	      etoile.go(buffer, time, true); break;
	  case 7 : scmiroir.go(buffer, time); break;
	  case 9 : fball.go(buffer, time); break;
	  case 10 : sable1.go(time, buffer); break;
	  case 12 :  
	    plan1.coord(time); // bouge les coordonnes du plan
	    plan1.plan_txt(buffer); // plan textur
	    break;
	  case 13 : myparts.go(buffer,time); break;
		  //case 14 : nova1.go(buffer,time-tdeb); break;
	  case 15 : fantom.go(buffer,time); break;
	  case 16 : landscape.palais(buffer); break;
	  case 17 : sarah_feu.go(buffer,time); break;
	  case 19 : marche.go(buffer,time); break;
	  case 21 : generic.go(buffer,time); break;
	  case 23 : diapofin.go(buffer,time); break;
	  case 253 : lettres2.go(buffer, time); break;
	  case 255 : greetings.go(buffer, time); break;
	  }
      }
      else break;
    }
    
    // Affichage 3D ;)
    rd.project(); // projection
    rd.zsort(); // tri suivant Z
    rd.go(); // Affichage des polygones
    rd.flush_polys(); // suppresion des polygones

    SDL_UpdateRects(screen, 1, &screen->clip_rect);
    SDL_Flip(screen);
    spent++;   // augmente le nb de frames
    UNLOCK_SURFACE(screen);
    UNLOCK_SURFACE(screentmp);
  }
  son2.del();
  printf("Frame/s moyen: %f\n",(float) (spent*1000.0)/ (float) (time-timeorig));
  printf("time: %d\n",time);
}

//end of main.cc
