#include "effets.h"

lettres::lettres( char *_phrase, Uint32 age_change_lettre, int fadespeed, int _mode, int _y ){
	nb = strlen(_phrase) & 0xFF;
	mode = _mode;
	fade = fadespeed;
	change = age_change_lettre;
	reset = true;
	expired = true;
	y = _y;
	strncpy(phrase, _phrase,255);
}

lettres::~lettres(){}

void lettres::raz( char *_phrase )
{
	nb = strlen(_phrase) & 0xFF;
	reset = true;
	if( _phrase )
		strncpy(phrase, _phrase,255);
}

bool lettres::go( Uint32 *buffer, Uint32 time )
{

	if( reset ) {
		timedeb = time;
	        for( int i=0; i<nb; i++ ){
                	lettre[i].active = false;
			lettre[i].expired = false;
                	if( mode == LETTRES_RANDOM ){
                        	lettre[i].x = rand()%586;
                        	lettre[i].y = rand()%416;
                	} else if( mode == LETTRES_CENTRE ) {
                        	lettre[i].x = (64*i) + 320 - (64*nb)/2;
                        	lettre[i].y = y;
                	}
                	lettre[i].lettre = phrase[i];
                	lettre[i].age = 0;
                	lettre[i].r = false;
                	lettre[i].lastmodif = time;
        	}
        	expired = false;
		reset = false;

	} else if( !expired ) {
		expired = true;
		for( int i=0; i < nb; i++ ) {
			if( !lettre[i].expired ){
			    if( lettre[i].active ){

				// AFFICHE
				if( lettre[i].lettre >= 'A' ||
				    lettre[i].lettre <= 'Z' ||
				    lettre[i].lettre == '[' )
					xlettre1.go(buffer, lettre[i].x, lettre[i].y,
						    lettre[i].lettre, lettre[i].age);

				// age de la lettre
				if( !lettre[i].r ){
					lettre[i].age += (time-lettre[i].lastmodif)/fade;
				} else {
					lettre[i].age -= (time-lettre[i].lastmodif)/fade;
				}

				if( lettre[i].age >= 255 ){
					lettre[i].r   = true;
					lettre[i].age = 255;
				}

                		if( lettre[i].age <   0 ) lettre[i].expired = true;
				lettre[i].lastmodif = time;
	
			    } else if( (time - timedeb) >= (change * i) ){
				lettre[i].active = true;
				lettre[i].lastmodif = time;
			    }
			    expired = false;
			}
		}
	}
	return !expired;
}

