// pour grer le son

#include "effets.h"

Son::Son(int marche, int TAVANCE, char *zik)
{
  SOUND = marche;

  // initialisation audio
  if (SOUND==1) {
    if (SDL_Init(SDL_INIT_AUDIO) < 0) {
      printf("No sound device available !\n");
      SOUND=0;
      return;
    }

    volume = 100;
    mpeg = SMPEG_new(zik, &info, SOUND);
	  
    if ( SMPEG_error(mpeg) ) {
      printf("%s\n", SMPEG_error(mpeg));
      SMPEG_delete(mpeg);
      SOUND = 0;
      return;
    }

    SMPEG_enableaudio(mpeg, SOUND);
    SMPEG_setvolume(mpeg, volume);

    /* Seek starting position */
    // SMPEG_seek(mpeg, 0); // bytes
    SMPEG_skip( mpeg, (float) TAVANCE/1000.0 ); // seconds
  }
}

void Son::vol(int vol)
{
  if (SOUND==1)
    SMPEG_setvolume(mpeg,vol);
}

void Son::del()
{
  if (SOUND==1) {
    SMPEG_delete(mpeg);
  }
}

Son::~Son()
{
}

void Son::start()
{
  if (SOUND==1) {
    /* Play it, and wait for playback to complete */
    SMPEG_play(mpeg);
  }
}

// end of son.cc
