%{
#include <stdio.h>
#include "timeparse.tab.cc.h"

void p(char *c)
{
//  printf("%s",c);
}

%}

%%
"pos"|"rot"             yylval=strdup(yytext); p("POS"); return POS;
[a-zA-Z][a-zA-Z0-9_]*	yylval=strdup(yytext); p("WORD"); return WORD;
-?[0-9]+"."[0-9]*       yylval=atof(yytext); p("FLOAT"); return FLOAT;
-?[0-9]+		yylval=atoi(yytext); p("NUMBER"); return NUMBER;
\n			p("\n"); /* do nothing */
[ \t]+			p(" "); /* ignore whitespace */;
#.*			/* ignore commentaires */;
%%

